# (C) 1994-2002 Dave Ackley.  All rights reserved.
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# My ancient Tcl-debugging-assist hacks

# A block commenter for {}-balanced schmutz
proc COMMENT args {}

# Flush the send command if it exists
catch { rename send {} }

# Quick whack-up to help with some of my typical tcl screwups
# Use 'Proc' as a 'drop-in replacement' for 'proc'..
# Stores state on hash 'ProcD'..
set ProcD(DebuggingCodeInAll) 0
        # 0 for max-speed no-debug
        # 1 to insert debugging code in every Proc

set ProcD(DebugEnter) 2
        # 0 to print no debugging info on procedure call
        # 1 to print procedure name on call
        # 2 to print procedure name and args on call

set ProcD(DebugLoading) 0
        # 0 to print no debugging info during loading
        # 1 to print procedure names as loaded

set ProcD(DebugFunctionList) ""
        # list of function names that should get debug code
        # inserted even without DebuggingCodeInAll

set ProcD(DebugPutsOnEnter) ""
        # optional text to insert in all proc entry debug output

proc Proc args {
    global ProcD
    set name [lindex $args 0]
    set alist [lindex $args 1]
    set body [lindex $args 2]
    set args $alist
    if {$ProcD(DebugLoading)} {
	puts "# ${name} $args";
    }
    if {$ProcD(DebuggingCodeInAll) || [lsearch $ProcD(DebugFunctionList) $name]>=0} {
	set more "\n global ProcD\n if {\$ProcD(DebugEnter)} {\n  puts -nonewline \" >$name\""
	if {[llength $alist]>0} {
	    set more "$more\n   if {\$ProcD(DebugEnter)>1} {"
	    foreach i $alist {
		if {[llength $i]>1} {
		    set i [lindex $i 0]
		}
		set more "$more\n    puts -nonewline \" <$i=\$$i>\""
	    }
	    if {$ProcD(DebugPutsOnEnter)!=""} {
		append more "
		    catch { puts -nonewline \"\n -|$ProcD(DebugPutsOnEnter)|- \" }
		"
	    }
	    set more "$more\n   }"
	}
	set more "$more\n  puts \"\"\n }"
	set body "$more\n$body"
    }
    eval "proc $name {$args} {$body}"
}

